[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.86 and 1.94

version 1.86, 2021/12/18 22:08:04 version 1.94, 2021/12/21 02:16:01
Line 34 
Line 34 
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}  FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub  FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
   DOWNLOAD=true
   INSTALL=true
 LOCALSRC=  LOCALSRC=
   
 tmpdir() {  tmpdir() {
Line 53 
Line 55 
 }  }
   
 fetch() {  fetch() {
         local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit _error=''
   
         # If we're not in the installer,          # If we're not in the installer,
         # we have su(1) and doas(1) is unlikely to be configured.          # we have su(1) and doas(1) is unlikely to be configured.
Line 82 
Line 84 
                                 sleep 1                                  sleep 1
                         else                          else
                                 kill -INT -"$_pid"                                  kill -INT -"$_pid"
                                 echo "fetch timed out" >&2                                  _error=" (timed out)"
                         fi                          fi
                 else                  else
                         sleep 1                          sleep 1
Line 98 
Line 100 
   
         if [ "$_exit" -ne 0 ]; then          if [ "$_exit" -ne 0 ]; then
                 rm -f "$_dst"                  rm -f "$_dst"
                 echo "Cannot fetch $_src" >&2                  echo "Cannot fetch $_src$_error" >&2
                 return 1                  return 1
         fi          fi
 }  }
Line 112 
Line 114 
 }  }
   
 devices_needing_firmware() {  devices_needing_firmware() {
         local _d _m _line _dmesgtail _last=''          local _d _m _line _dmesgtail _last='' _nl=$( echo )
   
         # When we're not in the installer, the dmesg.boot can          # When we're not in the installer, the dmesg.boot can
         # contain multiple boots, so only look in the last one          # contain multiple boots, so only look in the last one
         sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |          _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |
             grep -e "^[a-z][a-z]*[0-9]" -e " not configured " | { \              grep -e "^[a-z][a-z]*[0-9]" -e " not configured " )"
                 _m=0  
                 set -A _dmesgtail  
                 while read -r _line; do  
                         _dmesgtail[$_m]="$_line"  
                         _m=$(( _m + 1 ))  
                 done  
   
                 grep -v '^[[:space:]]*#' "$FWPATTERNS" |          grep -v '^[[:space:]]*#' "$FWPATTERNS" |
                     while read -r _d _m; do              while read -r _d _m; do
                         [ "$_d" = "$_last" ] && continue                  [ "$_d" = "$_last" ] && continue
                         [ "$_m" ] || _m="^${_d}[0-9] at "                  [ "$_m" ]             || _m="${_nl}${_d}[0-9] at "
                   [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
   
                         if [ "$_m" = "${_m#^}" ]; then                  if [[ $_dmesgtail = *$_m* ]]; then
                                 _m="*$_m"                          echo "$_d"
                         else                          _last="$_d"
                                 _m="${_m#^}"                  fi
                         fi              done
   
                         for _line in "${_dmesgtail[@]}"; do  
                                 if [[ $_line = ${_m}* ]]; then  
                                         echo "$_d"  
                                         _last="$_d"  
                                 fi  
                         done  
                     done  
         }  
 }  }
   
 firmware_filename() {  firmware_filename() {
Line 219 
Line 207 
 }  }
   
 usage() {  usage() {
         echo "usage: fw_install [-DL] [driver | file [...]]"          echo "usage:  ${0##*/} [-D | -L] [driver | file ...]"
         exit 2          exit 2
 }  }
   
 INSTALL=true  OPT_D=
 DOWNLOAD=true  OPT_L=
   
 while getopts DL name  while getopts DL name
 do  do
        case "$name" in         case "$name" in
        # "download only" means local dir and don't install         D) OPT_D=true ;;
        D) LOCALSRC=. INSTALL=false ;;         L) OPT_L=true ;;
        L) LOCALSRC=. ;;  
        ?) usage 2 ;;         ?) usage 2 ;;
        esac         esac
 done  done
 shift $((OPTIND - 1))  shift $((OPTIND - 1))
   
 # If we're installing from a local dir  [ "$OPT_D" ] && [ "$OPT_L" ] && usage 1
 # we don't want to download anything  
 [ "$LOCALSRC" ] && "$INSTALL" && DOWNLOAD=false  
 [ "$LOCALSRC" ] || LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"  
   
   if [ "$OPT_D" ]; then
           # "Download only" means local dir and don't install
           INSTALL=false
           LOCALSRC=.
   elif [ "$OPT_L" ]; then
           # "Local" means don't download, install from local dir
           DOWNLOAD=false
           LOCALSRC=.
   else
           LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"
   fi
   
 CFILE="$LOCALSRC/$CFILE"  CFILE="$LOCALSRC/$CFILE"
   
   if "$INSTALL" && [ -x /usr/bin/id ] && [ $(/usr/bin/id -u) != 0 ]; then
           echo "need root privileges" >&2
           exit 1
   fi
   
 set -A devices -- "$@"  set -A devices -- "$@"
   
 [ "${devices[*]:-}" ] ||  
     set -A devices -- $( devices_needing_firmware )  
   
 if [ ! "${devices[*]:-}" ]; then  if [ ! "${devices[*]:-}" ]; then
         echo "No devices found which need firmware files to be downloaded."          echo -n "Detecting firmware ..."
         exit          set -A devices -- $( devices_needing_firmware )
           [ "${devices[*]:-}" ] && echo " found." || echo " done."
 fi  fi
   
   [ "${devices[*]:-}" ] || exit
   
 if "$DOWNLOAD"; then  if "$DOWNLOAD"; then
         fetch "$CFILE"          fetch "$CFILE"

Legend:
Removed from v.1.86  
changed lines
  Added in v.1.94

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>